{*******************************************************}
{                                                       }
{       Java like Model-View classes                    }
{       ver 1.0.0                                       }
{       by srgia_jp@yahoo.co.jp                         }
{                                                       }
{*******************************************************}

unit srMVUnit;

interface

type

  TObserver = class;
  PObserver = ^TObserver;

  { fNX}
  TObservable = class
    private
      FObservers:array of TObserver;
      FChanged:boolean;
      function IndexOf(AObserver: TObserver): integer;
    protected
      procedure SetChanged;
      procedure ClearChanged;
    public
      constructor Create;
      procedure AddObserver(AObserver: TObserver);
      function CountObservers:integer;
      procedure DeleteObserver(AObserver: TObserver);
      procedure DeleteObservers;
      function HasChanged:boolean;
      procedure NotifyObservers; overload;
      procedure NotifyObservers(AArg: TObject); overload;
  end;

  { r[NX
    1̉z\bĥ݂Ŏ͂܂B}
  TObserver = class
    public
      procedure Update(AObservable:TObservable; AArg:TObject);virtual;abstract;
  end;

implementation

{ TObservable
  Model-Viewɂ郂fɑ܂B }

{ TObservable.AddObserver
  r[֘At܂B}
procedure TObservable.AddObserver(AObserver: TObserver);
var
  i,NewIndex:integer;
begin

  if(IndexOf(AObserver) >= 0)then Exit;

  NewIndex := -1;
  for i := 0 to Length(FObservers) - 1 do
  begin
    if(not Assigned(FObservers[i]))then
    begin
      NewIndex := i;
      Break;
    end;
  end;

  if(NewIndex = -1)then
  begin
    SetLength(FObservers, Length(FObservers) + 1);
    NewIndex := Length(FObservers) - 1;
  end;

  FObservers[NewIndex] := AObserver;

end;

{ TObservable.ClearChanged
  ύXtONA܂B}
procedure TObservable.ClearChanged;
begin

  FChanged := False;

end;

{ TObservable.CountObservers
  ֘AtĂr[̐Ԃ܂B}
function TObservable.CountObservers: integer;
var
  i:integer;
begin

  Result := 0;
  for i := 0 to Length(FObservers) - 1 do
  begin
    if(Assigned(FObservers[i]))then
    begin
      Inc(Result);
    end;
  end;

end;

{ TObservable.Create
  RXgN^}
constructor TObservable.Create;
begin

  inherited;

  FChanged := False;

end;

{ TObservable.DeleteObserver
  ̃r[Ƃ̊֘At폜܂B}
procedure TObservable.DeleteObserver(AObserver: TObserver);
begin

  if(IndexOf(AObserver) = -1)then Exit;

  FObservers[IndexOf(AObserver)] := nil;

end;

{ TObservable.DeleteObservers
  SẴr[Ƃ̊֘At폜܂B}
procedure TObservable.DeleteObservers;
var
  i:integer;
begin

  for i := 0 to Length(FObservers) - 1 do
  begin
    FObservers[i] := nil;
  end;

end;

{ TObservable.HasChanged
  ύXtȌԂԂ܂B}
function TObservable.HasChanged: boolean;
begin

  Result := FChanged;

end;

{ TObservable.IndexOf
  ̃r[̃CfbNXԂPrivate\bhłB}
function TObservable.IndexOf(AObserver: TObserver): integer;
var
  i:integer;
begin

  Result := -1;
  for i := 0 to Length(FObservers) - 1 do
  begin
    if(FObservers[i] = AObserver)then
    begin
      Result := i;
      Exit;
    end;
  end;

end;

{ TObservable.NotifyObservers
  ֘AtĂSẴr[ɑ΂ĕύXʒm܂BtB}
procedure TObservable.NotifyObservers(AArg: TObject);
var
  i:integer;
begin

  if(not HasChanged)then Exit;

  for i := 0 to Length(FObservers) - 1 do
  begin
    if(Assigned(FObservers[i]))then
    begin
      FObservers[i].Update(Self, AArg);
    end;
  end;

  ClearChanged;

end;

{ TObservable.NotifyObservers
  ֘AtĂSẴr[ɑ΂ĕύXʒm܂B}
procedure TObservable.NotifyObservers;
begin

  NotifyObservers(nil);

end;

{ TObservable.SetChanged
  ύXtOZbg܂B}
procedure TObservable.SetChanged;
begin

  FChanged := True;

end;

end.
